############################################################
# This script accompanies the book "Windows NT Configuration
# and Maintenance" by Matthew M Lavy and Ashley J Meggitt
# (published by O'Reilly, 1999)
# The script is copyright, 1999 Matthew Lavy & Ashley Meggitt
# 
# WARNING: This script is provided in electronic format as a
# convenience for readers of the book it accompanies. It may
# well require site-specific customisation before it works at
# all, and may cause damage to a workstation if run without this
# customisation (please refer to the book for details).
# DO NOT RUN THIS SCRIPT UNLESS YOU HAVE CHECKED THOROUGHLY THAT
# IT IS SAFE TO DO SO. The authors accept no liability for any
# damage caused by running the script.


# remotemac.pl

use Win32::Registry;

$filename = shift @ARGV;
open(NETNAMES,$filename);
open(MACADDS,">addresses.mac");

$filename = shift @ARGV;
open(NETNAMES,$filename);
open(MACADDS,">addresses.mac");

MACHINE: while ($remotemachine = <NETNAMES>)
{
chomp($remotemachine);
unless (Win32::Registry::RegConnectRegistry
($remotemachine, HKEY_LOCAL_MACHINE, $RemoteHandle))
{
print "Cannot connect to $remotemachine\n";
next MACHINE;
}
print "\nRemote Registry accessed on - $remotemachine\n";

$key = 'SOFTWARE\Description\Microsoft\Rpc\UuidTemporaryData';
unless(Win32::Registry::RegOpenKeyEx
($RemoteHandle,$key,NULL,KEY_ALL_ACCESS,$RegHandle))
{
Win32::Registry::RegCloseKey ($RemoteHandle);
print "Unable to retrieve values\n";
next MACHINE;
}

$index=0;
while(Win32::Registry::RegEnumValue
($RegHandle,$index++,$VName,NULL,$VType,$VData))
{
<Picture>$values {$VName} = [$VName, $VType, $VData];
}

Win32::Registry::RegCloseKey($RegHandle);
Win32::Registry::RegCloseKey($RemoteHandle);

foreach (keys (%values))
{
if ($_ eq "NetworkAddress")
{
$MACaddress = unpack "H12",$values{$_}[2];
print "MAC address is: $MACaddress\n";
print MACADDS "$remotemachine-$MACaddress\n";
}
}
}

close(MACADDS);
close(NETNAMES);